from typing import List
import PyPDF2
from tika import unpack
from .base import Engine


class FileEngine(Engine):
    def __init__(self):
        super().__init__()

    def forward(self, *args, **kwargs) -> List[str]:
        path = kwargs['prompt']
        input_handler = kwargs['input_handler'] if 'input_handler' in kwargs else None
        if input_handler:
            input_handler((path,))

        if 'pdf' in path:
            rsp = ''
            with open(str(path), 'rb') as f:
                # creating a pdf reader object
                pdf_reader = PyPDF2.PdfReader(f)
                n_pages = len(pdf_reader.pages)
                if 'n_pages' in kwargs:
                    n_pages = kwargs['n_pages']
                for i in range(n_pages):
                    page = pdf_reader.pages[i]
                    rsp += page.extract_text()
        else:
            rsp = unpack.from_file(str(path))['content']

        output_handler = kwargs['output_handler'] if 'output_handler' in kwargs else None
        if output_handler:
            output_handler(rsp)

        return [rsp]

    def prepare(self, args, kwargs, wrp_params):
        pass
